PRO IRISl12_calc, files, Nfiles, dest, nuv=nuv

  ;get number of rasters, and their start and end file
  ; a raster ends if the sign of dpztx changes
  startraster=[0]
  for filenr=0,Nfiles-1 do begin
    fxread, files[filenr], data, header, /nodata
    pztx = fxpar(header, 'PZTX')
    
    if filenr gt 0 then begin
      dpztx = pztx - pztxold
      if dpztx ne 0 then dpztx=dpztx/abs(dpztx)
      if dpztxold ne 9 then begin ;if this is not the second take of a raster
        if dpztx ne dpztxold then begin ;raster ends, start a new one
          if N_ELEMENTS(startraster) eq 1 then endraster = filenr-1 $
          else endraster = [endraster, filenr-1]
          startraster = [startraster, filenr]
          dpztxold = 9
        endif
      endif else dpztxold=dpztx
    endif else begin
      dpztxold = 9
    endelse
    pztxold = pztx
  endfor ;files
  endraster = [endraster, filenr-1]
  
  print, 'found', N_ELEMENTS(startraster), ' rasters'
  print, 'starts ', startraster
  print, 'ends   ', endraster
  
  void = {rastreg, OBSid:'', FDBid:'', CRSid:'', desc:'', $
    startrow:0L, numrows:0L, startcol:0L, numcols:0L, $
    data:ptr_new()}
    
  for raster=0,N_ELEMENTS(startraster)-1 do begin
    numsteps = endraster[raster] - startraster[raster] + 1
    ;for i=0,numregions-1 do rasterdata[i] = ptr_new(fltarr(numrows[i], numcols[i], numsteps))
    auxdata = fltarr(numsteps, 3)
    
    for filenr=0,numsteps-1 do begin
      fxread, files[filenr+startraster[raster]], data, header
      auxdata[filenr,0] = fxpar(header, 'TIME')
      auxdata[filenr,1] = fxpar(header, 'PZTX')
      auxdata[filenr,2] = fxpar(header, 'PZTY')
      
      OBSid = fxpar(header, 'OBSID')
      FDBid = fxpar(header, 'FDBID')
      CRSid = fxpar(header, 'CRSID')
      
      numregions = fxpar(header, 'REGTOT')
      startrow = fxpar(header, 'ROWSTAR*')
      numrows = fxpar(header, 'ROWNUM*')
      startcol = fxpar(header, 'COLSTAR*')
      numcols = fxpar(header, 'COLNUM*')
      regdesc = fxpar(header, 'REGDESC*')
      
      sumspec = fxpar(header, 'SUMSPEC')
      sumspat = fxpar(header, 'SUMSPAT')
      
      if keyword_set(nuv) then startrow = startrow - nuv
      
      if filenr eq 0 then begin
        regdata = void
        regdata.OBSid = OBSid
        regdata.FDBid = FDBid
        regdata.CRSid = CRSid
        regdata = REPLICATE(regdata, numregions)
        for i=0,numregions-1 do $
          regdata[i].data = ptr_new(fltarr(numrows[i], numcols[i], numsteps))
      endif
      
      ind = where(regdata.CRSid eq CRSid, count)
      if (count gt 0) && (count ne numregions) then begin
        print, 'strange...'
      endif else if count eq 0 then begin
        ;check if these regions already exist, just with different sumspec/sumspat
        ind=intarr(numregions)
        for regs=0,numregions-1 do begin
          indrow = where(regdata.startrow eq startrow[regs], count2)
          notexist=1
          ;stop
          if count2 gt 0 then begin
            for i=0,N_ELEMENTS(indrow)-1 do begin
              if (regdata[indrow].numrows eq numrows[regs]) && $
                (regdata[indrow].startcol eq startcol[regs]) && $
                (regdata[indrow].numcols eq numcols[regs]) then begin
                ind[regs] = indrow
                notexist=0
                break
              endif
            endfor
          endif
          if notexist then begin
            ;if it doesn't exist yet, create new region
            regdata2 = void
            regdata2.OBSid = OBSid
            regdata2.FDBid = FDBid
            regdata2.CRSid = CRSid
            regdata2.data = ptr_new(fltarr(numrows[regs], numcols[regs], numsteps))
            regdata = [regdata, regdata2]
            ind[regs] = N_ELEMENTS(regdata)-1
          endif
        endfor
        
      endif ;new CRS (if count)
      
      
      srf = startrow / sumspec
      nrf = numrows / sumspec
      scf = startcol / sumspat
      ncf = numcols / sumspat
      for i=0,N_ELEMENTS(ind)-1 do begin
        regdata[ind[i]].startrow = startrow[i]
        regdata[ind[i]].numrows = numrows[i]
        regdata[ind[i]].startcol = startcol[i]
        regdata[ind[i]].numcols = numcols[i]
        regdata[ind[i]].desc = regdesc[i]
        (*(regdata[ind[i]]).data)[*,*,filenr] = congrid(data[srf[i]:srf[i]+nrf[i]-1, scf[i]:scf[i]+ncf[i]-1], numrows[i], numcols[i])
      endfor
      
      ;print, CRSid, N_ELEMENTS(regdata)
      
    endfor ;filenr
    ;for i=0,N_ELEMENTS(regdata)-1 do help,*(regdata[i]).data
    
    
    
    
    ;we have a new raster, now we save it into a fits file
    if keyword_set(nuv) then file2=dest+fns('IRIS_NUV_raster_t000_r####.fits',raster) $
    else file2=dest+fns('IRIS_FUV_raster_t000_r####.fits',raster)
    for region=0,N_ELEMENTS(regdata)-1 do begin
      if region eq 0 then begin
        ;first region is written into primary block
        mkhdr, header, *(regdata[region]).data, /extend
        ;add some information to the primary header
        sxaddpar, header, 'OBSID', regdata[region].OBSid, 'OBS List ID'
        sxaddpar, header, 'REGTOT', N_ELEMENTS(regdata), 'Number of Regions'
        sxaddpar, header, 'COMMENT', 'Matrix: [wavelength, y, t/x]'
        sxaddpar, header, 'COMMENT', 'There is an additional extension with auxiliary data'
      endif else $
        mkhdr, header, *(regdata[region]).data, /image
        
      ;add information to all headers
      sxaddpar, header, 'FDBID', regdata[region].FDBid, 'FDB List ID'
      sxaddpar, header, 'CRSID', regdata[region].CRSid, 'CRS List ID'
      sxaddpar, header, 'ROWSTAR', regdata[region].startrow, 'Startrow'
      sxaddpar, header, 'ROWNUM', regdata[region].numrows, 'Number of Rows'
      sxaddpar, header, 'COLSTAR', regdata[region].startcol, 'Startcolumn'
      sxaddpar, header, 'COLNUM', regdata[region].numcols, 'Number of Columns'
      sxaddpar, header, 'DESC', regdata[region].desc, 'The name of the spectral line in this region'
      
      if region eq 0 then $
        writefits, file2, *(regdata[region]).data, header $
      else $
        writefits, file2, *(regdata[region]).data, header, /append
        
    endfor ;regions
    
    ;write last extension with auxiliary data (time, PZTX, PZTY)
    mkhdr, header, auxdata, /image
    sxaddpar, header, 'COMMENT', 'Auxiliary data'
    sxaddpar, header, 'COMMENT', '[*,0]=time [ms], [*,1]=PZTX [arcsec], [*,2]=PZTY [acrsce]'
    writefits, file2, auxdata, header, /append
    
    
  endfor ;raster
END
