pro IRISsim_writeLogFile, savelogcsv, savelogtxt, logFilecsvName, logFiletxtName, csvUnit, txtUnit, header, endline, $
    step, time, fdbsji, fdbfuv, fdbnuv, crssji, crsfuv, crsnuv, $
    PZTcurrent, nrOBSrepeats, nrFRM, nrFRMrepeats, nrFDB, $
    FW, FRMid, $
    LUT, CompN, CompK, Focus, Flushcurrent, exposures, $
    sim1, sim2, sim3, sim4, $
    filedirfuv=filedirfuv, filedirnuv=filedirnuv, datestamp=datestamp, OBSid=OBSid, version=version
    
  if header then begin
    ;create header of logfiles
  
    ;create csv-logfile
    if savelogcsv then begin
      logFilecsvName=datestamp+'/'+OBSid+'_log.csv'
      OpenW, csvUnit, logFilecsvName, /get_lun
      log='Log of IRIS simulator,Version:,'+version
      printf, csvUnit, log
      log='OBS ID:,'+OBSid
      printf, csvUnit, log
      log='Path of input files,FUV:,'+filedirfuv
      printf, csvUnit, log
      log=',NUV:,'+filedirnuv
      printf, csvUnit, log
      log='Image nr,Time [s],Type,OBSrep,OBSentry,FRMrep,FRMentry,'+$
        'PZTx,PZTy,PZTA,PZTB,PZTC,'+$
        'FW,Focus,Flush,'+$
        'FRM ID,FDB ID,CRS ID,'+$
        'LUT,CompN,CompK,Exp [ms],'+$
        'File 1 FUV,File 2 FUV,File 1 NUV,File 2 NUV'
      printf, csvUnit, log
      Close, csvUnit
    endif
    
    ;create txt-logfile
    if savelogtxt then begin
      logFiletxtName=datestamp+'/'+OBSid+'_log.txt'
      OpenW, txtUnit, logFiletxtName, /get_lun
      log='Log of IRIS simulator; Version: '+version
      printf, txtUnit, log
      log='OBS ID: '+OBSid
      printf, txtUnit, log
      log='Path of input files; FUV: '+filedirfuv
      printf, txtUnit, log
      log='                     NUV: '+filedirnuv
      printf, txtUnit, log
      log=' IM nr | Time [s] | Type | OBSrep | OBSentry | FRMrep | FRMentry | '+$
        '   PZTx |    PZTy | '+$
        '  FW | Focus | Flush | '+$
        ' FRM ID |  FDB ID |  CRS ID | '+$
        ' LUT | CompN | CompK | Exp [ms] | '+$
        'File1 F | File2 F | File1 N | File2 N'
      l=strlen(log)
      log2='='
      for i=0,l-2 do log2=log2+'='
      printf, txtUnit, log2
      printf, txtUnit, log
      printf, txtUnit, log2
      Close, txtUnit
    endif
    
  endif else begin
  
    tim=time/1000.
    
    if endline then begin
      ;write last line with the endtime
    
      if savelogcsv then begin
        OpenU, csvUnit, logFilecsvName, /append
        log=string(tim)
        log=strcompress(log,/remove_all)
        printf, csvUnit, log
        Close, csvUnit
        free_lun, csvUnit
      endif
      
      if savelogtxt then begin
        OpenU, txtUnit, logFiletxtName, /append
        log=string(tim, format='(f9.3)')+' |'
        printf, txtUnit, log
        Close, txtUnit
        free_lun, txtUnit
      endif
      
    endif else begin
      ;write data into files
    
      pztabc = IRISsim_xy2pzt(PZTcurrent[0], PZTcurrent[1])
      
      ;write to the csv-log file
      if savelogcsv then begin
        OpenU, csvUnit, logFilecsvName, /append
        for k=0,2 do begin
          case k of
            0: begin
              fdbid=fdbsji
              crsid=crssji
              type='SJI'
            end
            1: begin
              fdbid=fdbfuv
              crsid=crsfuv
              type='FUV'
            end
            2: begin
              fdbid=fdbnuv
              crsid=crsnuv
              type='NUV'
            end
          endcase
          if fdbid ne '-' then begin
            log=string(step)+','+$
              string(tim)+','+$
              type+','+$
              string(nrOBSrepeats+1)+','+$
              string(nrFRM+1)+','+$
              string(nrFRMrepeats+1)+','+$
              string(nrFDB+1)+','+$
              string(PZTcurrent[0])+','+$
              string(PZTcurrent[1])+','+$
              string(pztabc[0])+','+$
              string(pztabc[1])+','+$
              string(pztabc[2])+','+$
              string(FW)+','+$
              string(Focus)+','+$
              string(Flushcurrent)+','+$
              FRMid+','+$
              fdbid+','+$
              crsid+','+$
              LUT[k]+','+$
              string(CompN[k])+','+$
              string(CompK[k])+','+$
              string(exposures[k])+','+$
              string(sim1)+','+$
              string(sim2)+','+$
              string(sim3)+','+$
              string(sim4)
            log=strcompress(log,/remove_all)
            printf, csvUnit, log
          endif
        endfor ;k
        Close, csvUnit
      endif
      
      ;write to the txt-log file
      if savelogtxt then begin
        OpenU, txtUnit, logFiletxtName, /append
        for k=0,2 do begin
          case k of
            0: begin
              fdbid=fdbsji
              crsid=crssji
              type='SJI'
            end
            1: begin
              fdbid=fdbfuv
              crsid=crsfuv
              type='FUV'
            end
            2: begin
              fdbid=fdbnuv
              crsid=crsnuv
              type='NUV'
            end
          endcase
          if fdbid ne '-' then begin
            for i=strlen(fdbid),strlen(FRMid)-1 do fdbid=' '+fdbid
            for i=strlen(crsid),strlen(FRMid)-1 do crsid=' '+crsid
            for i=strlen(LUT[k]),3 do LUT[k]=' '+LUT[k]
            log=string(step, format='(I6)')+' | '+$
              string(tim, format='(f8.3)')+' | '+$
              ' '+type+' | '+$
              string(nrOBSrepeats+1, format='(I6)')+' | '+$
              string(nrFRM+1, format='(I8)')+' | '+$
              string(nrFRMrepeats+1, format='(I6)')+' | '+$
              string(nrFDB+1, format='(I8)')+' | '+$
              string(PZTcurrent[0], format='(f7.3)')+' | '+$
              string(PZTcurrent[1], format='(f7.3)')+' | '+$
              string(FW, format='(I4)')+' | '+$
              string(Focus, format='(I5)')+' | '+$
              string(Flushcurrent, format='(I5)')+' | '+$
              FRMid+' | '+$
              fdbid+' | '+$
              crsid+' | '+$
              LUT[k]+' | '+$
              string(CompN[k], format='(I5)')+' | '+$
              string(CompK[k], format='(I5)')+' | '+$
              string(exposures[k], format='(I8)')+' | '+$
              string(sim1, format='(I7)')+' | '+$
              string(sim2, format='(I7)')+' | '+$
              string(sim3, format='(I7)')+' | '+$
              string(sim4, format='(I7)')
            printf, txtUnit, log
          endif
        endfor ;k
        Close, txtUnit
      endif
      
    endelse
    
  endelse
  
end
